=== debian/changelog ===
intel-compute-runtime (19.13.12717-0ubuntu1) disco; urgency=medium

  * Upload to Ubuntu. (LP: #1815552)

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 10 Apr 2019 21:16:26 +0300

intel-compute-runtime (19.13.12717-1) UNRELEASED; urgency=medium

  * Initial release (Closes: #926706)

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 04 Feb 2019 11:15:41 +0200
